#include <Keypad.h>
#include <EEPROM.h>

int buttonState = 0;
const byte rows = 5;
const byte cols = 3;
char keys[rows][cols] = {
{'a','f','k'}, 
{'b','g','l'},
{'c','h','m'},
{'d','i','n'},
{'e','j','o'} 
};
/* The row a-e - cases for live/setup mode. rotary switch in posiition (1) on pin 7
   The row f-j - cases for save preset to memory. rotary switch in posiition (2) on pin 8
   The row k-o - cases for read preset from memory. rotary switch in posiition (3) on pin 9
*/
byte rowPins[rows] = {2, 3, 4, 5, 6};
byte colPins[cols] = {7, 8, 9};
Keypad kpd = Keypad(makeKeymap(keys), rowPins, colPins, rows, cols);

void setup()
{
pinMode(10, OUTPUT); //relay pins 10 -> 14
pinMode(11, OUTPUT);
pinMode(12, OUTPUT);
pinMode(13, OUTPUT);
pinMode(14, OUTPUT);
pinMode(15, OUTPUT); //led pins 15 -> 19
pinMode(16, OUTPUT);
pinMode(17, OUTPUT);
pinMode(18, OUTPUT);
pinMode(19, OUTPUT);
pinMode(20, INPUT);  
    
//for (int i = 0; i < 512; i++) // erase eeprom each start of device. if you need it - uncomment this two strings. 
//    EEPROM.write(i, 0); 

}

void loop()
{
  char key = kpd.getKey();
  buttonState = digitalRead(20); // check if the pushbutton is pressed. if it is, the buttonState is HIGH:
  if (buttonState == HIGH) {     
    // turn all leds and relays to off. "Bypass All" button.   
    digitalWrite(10, LOW);
    digitalWrite(11, LOW);
    digitalWrite(12, LOW);
    digitalWrite(13, LOW);
    digitalWrite(14, LOW);
    digitalWrite(15, LOW);
    digitalWrite(16, LOW);
    digitalWrite(17, LOW);
    digitalWrite(18, LOW);
    digitalWrite(19, LOW);  
  }
  
  if(key)  // Check for a valid key.
  {
    switch (key)
      { 
    case 'a':  // a to e = select wich relay is HIGH/LOW
      digitalWrite(10, !digitalRead(10)); // Change the relay from Hi2Lo or Lo2Hi.
      digitalWrite(15, !digitalRead(15)); // Change the led from Hi2Lo or Lo2Hi.
      break; 
    case 'b': 
      digitalWrite(11, !digitalRead(11));
      digitalWrite(16, !digitalRead(16));
      break; 
    case 'c': 
      digitalWrite(12, !digitalRead(12));
      digitalWrite(17, !digitalRead(17));
      break;
    case 'd': 
      digitalWrite(13, !digitalRead(13));
      digitalWrite(18, !digitalRead(18));
      break;
    case 'e': 
      digitalWrite(14, !digitalRead(14));
      digitalWrite(19, !digitalRead(19));
      break;  
      
//----------------------------------------------------   

    case 'f': // store presets case
      EEPROM.write(10, digitalRead(10));
      EEPROM.write(11, digitalRead(11));
      EEPROM.write(12, digitalRead(12));
      EEPROM.write(13, digitalRead(13));
      EEPROM.write(14, digitalRead(14));
      digitalWrite(15, LOW);
      digitalWrite(16, LOW);
      digitalWrite(17, LOW);
      digitalWrite(18, LOW);
      digitalWrite(19, LOW);
      delay(300);
      digitalWrite(15, HIGH);
      delay(300); 
      digitalWrite(15, LOW);
      delay(300); 
      digitalWrite(15, HIGH);
      delay(300);
      digitalWrite(15, LOW);
      delay(300); 
      digitalWrite(15, HIGH);
      break;
    case 'g': // store presets case
      EEPROM.write(20, digitalRead(10));
      EEPROM.write(21, digitalRead(11));
      EEPROM.write(22, digitalRead(12));
      EEPROM.write(23, digitalRead(13));
      EEPROM.write(24, digitalRead(14));
      digitalWrite(15, LOW);
      digitalWrite(16, LOW);
      digitalWrite(17, LOW);
      digitalWrite(18, LOW);
      digitalWrite(19, LOW);
      delay(300);
      digitalWrite(16, HIGH);
      delay(300); 
      digitalWrite(16, LOW);
      delay(300); 
      digitalWrite(16, HIGH);
      delay(300); 
      digitalWrite(16, LOW);
      delay(300); 
      digitalWrite(16, HIGH);
      break;
    case 'h': // store presets case
      EEPROM.write(30, digitalRead(10));
      EEPROM.write(31, digitalRead(11));
      EEPROM.write(32, digitalRead(12));
      EEPROM.write(33, digitalRead(13));
      EEPROM.write(34, digitalRead(14));
      digitalWrite(15, LOW);
      digitalWrite(16, LOW);
      digitalWrite(17, LOW);
      digitalWrite(18, LOW);
      digitalWrite(19, LOW);
      delay(300);
      digitalWrite(17, HIGH);
      delay(300); 
      digitalWrite(17, LOW);
      delay(300); 
      digitalWrite(17, HIGH);
      delay(300); 
      digitalWrite(17, LOW);
      delay(300); 
      digitalWrite(17, HIGH);
      break;
    case 'i': // store presets case
      EEPROM.write(40, digitalRead(10));
      EEPROM.write(41, digitalRead(11));
      EEPROM.write(42, digitalRead(12));
      EEPROM.write(43, digitalRead(13));
      EEPROM.write(44, digitalRead(14));
      digitalWrite(15, LOW);
      digitalWrite(16, LOW);
      digitalWrite(17, LOW);
      digitalWrite(18, LOW);
      digitalWrite(19, LOW);
      delay(300);
      digitalWrite(18, HIGH);
      delay(300); 
      digitalWrite(18, LOW);
      delay(300); 
      digitalWrite(18, HIGH);
      delay(300); 
      digitalWrite(18, LOW);
      delay(300); 
      digitalWrite(18, HIGH);
      break;
    case 'j': // store presets case
      EEPROM.write(40, digitalRead(10));
      EEPROM.write(41, digitalRead(11));
      EEPROM.write(42, digitalRead(12));
      EEPROM.write(43, digitalRead(13));
      EEPROM.write(44, digitalRead(14));
      digitalWrite(15, LOW);
      digitalWrite(16, LOW);
      digitalWrite(17, LOW);
      digitalWrite(18, LOW);
      digitalWrite(19, LOW);
      delay(300);
      digitalWrite(19, HIGH);
      delay(300); 
      digitalWrite(19, LOW);
      delay(300); 
      digitalWrite(19, HIGH);
      delay(300); 
      digitalWrite(19, LOW);
      delay(300); 
      digitalWrite(19, HIGH);
      break;
      
//----------------------------------------------------    

     case 'k': // read presets case
      digitalWrite(10,EEPROM.read(10));
      digitalWrite(11,EEPROM.read(11));
      digitalWrite(12,EEPROM.read(12));
      digitalWrite(13,EEPROM.read(13));
      digitalWrite(14,EEPROM.read(14));
      digitalWrite(15,HIGH);
      digitalWrite(16,LOW);
      digitalWrite(17,LOW);
      digitalWrite(18,LOW);
      digitalWrite(19,LOW);
      break;
     case 'l': // read presets case
      digitalWrite(10,EEPROM.read(20));
      digitalWrite(11,EEPROM.read(21));
      digitalWrite(12,EEPROM.read(22));
      digitalWrite(13,EEPROM.read(23));
      digitalWrite(14,EEPROM.read(24));;
      digitalWrite(16,HIGH);
      digitalWrite(15,LOW);
      digitalWrite(17,LOW);
      digitalWrite(18,LOW);
      digitalWrite(19,LOW);
      break;
     case 'm': // read presets case
      digitalWrite(10,EEPROM.read(30));
      digitalWrite(11,EEPROM.read(31));
      digitalWrite(12,EEPROM.read(32));
      digitalWrite(13,EEPROM.read(33));
      digitalWrite(14,EEPROM.read(34));
      digitalWrite(17,HIGH);
      digitalWrite(15,LOW);
      digitalWrite(16,LOW);
      digitalWrite(18,LOW);
      digitalWrite(19,LOW);
      break;
     case 'n': // read presets case
      digitalWrite(10,EEPROM.read(40));
      digitalWrite(11,EEPROM.read(41));
      digitalWrite(12,EEPROM.read(42));
      digitalWrite(13,EEPROM.read(43));
      digitalWrite(14,EEPROM.read(44));
      digitalWrite(18,HIGH);
      digitalWrite(15,LOW);
      digitalWrite(16,LOW);
      digitalWrite(17,LOW);
      digitalWrite(19,LOW);
      break;
     case 'o': // read presets case
      digitalWrite(10,EEPROM.read(50));
      digitalWrite(11,EEPROM.read(51));
      digitalWrite(12,EEPROM.read(52));
      digitalWrite(13,EEPROM.read(53));
      digitalWrite(14,EEPROM.read(54));
      digitalWrite(19,HIGH);
      digitalWrite(15,LOW);
      digitalWrite(16,LOW);
      digitalWrite(17,LOW);
      digitalWrite(18,LOW);
      break; 
      }       
   }
}
